use rocket::{get, http::ContentType, routes, Route, State};
use sqlx::SqlitePool;

use crate::model::{event::Event, personal::cal::get_personal_cal, user::User};

#[get("/cal")]
async fn cal(db: &State<SqlitePool>) -> (ContentType, String) {
    //TODO: add unit test once proper functionality is there
    (ContentType::Calendar, Event::get_ics_feed(db).await)
}

#[get("/cal/registered")]
async fn cal_registered(db: &State<SqlitePool>, user: User) -> (ContentType, String) {
    //TODO: add unit test once proper functionality is there
    (ContentType::Calendar, get_personal_cal(db, &user).await)
}

pub fn routes() -> Vec<Route> {
    routes![cal, cal_registered]
}

#[cfg(test)]
mod test {
    use rocket::{http::Status, local::asynchronous::Client};
    use sqlx::SqlitePool;

    use crate::testdb;

    #[sqlx::test]
    fn test_without_login() {
        let db = testdb!();

        let rocket = rocket::build().manage(db.clone());
        let rocket = crate::tera::config(rocket);

        let client = Client::tracked(rocket).await.unwrap();

        let req = client.get("/");
        let response = req.dispatch().await;

        assert_eq!(response.status(), Status::SeeOther);
        assert_eq!(response.headers().get("Location").next(), Some("/auth"));
    }
}
